// Test Std functions and exceptions
// $Id: t16.g,v 1.1 2002/02/25 11:14:44 malekith Exp $

int matcher(string s)
{
	switch s {
	case "foo":
		return 1;
	case "bar":
		return 2;
	case _:
		return 3;
	}
}

void choke()
{
	<int>Slist::t foo = null;

	foo.data = 5;
}

void main()
{
	int i = atoi("12");
	float f;
	
	print_int(i);
	print_string(" ");
	try {
		i = atoi("12foo");
	} with {
	case Invalid_argument[s]:
		print_string(strjoin(s, " "));
	}

	f = atof("12.5");
	print_float(f);
	print_string(" ");

	try {
		f = atof("baz12.5");
	} with {
	case Invalid_argument[s]:
		print_string(strjoin(s, " "));
	}

	print_int(matcher("foo"));
	print_int(matcher("bar"));
	print_int(matcher("baz"));

	try {
		choke();
		print_string(" ??? ");
	} with {
	case Null_access:
		print_string(" NULL ");
	}
	
	print_endline("foo" + "bar" + "baz");
}

section init 
{
	main();
}

/* 
 * expected-build-status: ok
 * run-test: yes
 * expected-output: 12 Std::atoi 12.5 Std::atof 123 NULL foobarbaz
 */
